// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package contacts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/crm/crm_models"
)

// DeleteContactReader is a Reader for the DeleteContact structure.
type DeleteContactReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *DeleteContactReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewDeleteContactOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewDeleteContactUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewDeleteContactForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewDeleteContactNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewDeleteContactUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewDeleteContactInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewDeleteContactOK creates a DeleteContactOK with default headers values
func NewDeleteContactOK() *DeleteContactOK {
	return &DeleteContactOK{}
}

/*
DeleteContactOK describes a response with status code 200, with default header values.

Response with Message Objects with Delete Status
*/
type DeleteContactOK struct {
	AccessControlAllowOrigin string

	Payload *crm_models.DeleteResponse
}

// IsSuccess returns true when this delete contact o k response has a 2xx status code
func (o *DeleteContactOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this delete contact o k response has a 3xx status code
func (o *DeleteContactOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete contact o k response has a 4xx status code
func (o *DeleteContactOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete contact o k response has a 5xx status code
func (o *DeleteContactOK) IsServerError() bool {
	return false
}

// IsCode returns true when this delete contact o k response a status code equal to that given
func (o *DeleteContactOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the delete contact o k response
func (o *DeleteContactOK) Code() int {
	return 200
}

func (o *DeleteContactOK) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactOK  %+v", 200, o.Payload)
}

func (o *DeleteContactOK) String() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactOK  %+v", 200, o.Payload)
}

func (o *DeleteContactOK) GetPayload() *crm_models.DeleteResponse {
	return o.Payload
}

func (o *DeleteContactOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.DeleteResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactUnauthorized creates a DeleteContactUnauthorized with default headers values
func NewDeleteContactUnauthorized() *DeleteContactUnauthorized {
	return &DeleteContactUnauthorized{}
}

/*
DeleteContactUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type DeleteContactUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this delete contact unauthorized response has a 2xx status code
func (o *DeleteContactUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete contact unauthorized response has a 3xx status code
func (o *DeleteContactUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete contact unauthorized response has a 4xx status code
func (o *DeleteContactUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete contact unauthorized response has a 5xx status code
func (o *DeleteContactUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this delete contact unauthorized response a status code equal to that given
func (o *DeleteContactUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the delete contact unauthorized response
func (o *DeleteContactUnauthorized) Code() int {
	return 401
}

func (o *DeleteContactUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteContactUnauthorized) String() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnauthorized  %+v", 401, o.Payload)
}

func (o *DeleteContactUnauthorized) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactForbidden creates a DeleteContactForbidden with default headers values
func NewDeleteContactForbidden() *DeleteContactForbidden {
	return &DeleteContactForbidden{}
}

/*
DeleteContactForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type DeleteContactForbidden struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this delete contact forbidden response has a 2xx status code
func (o *DeleteContactForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete contact forbidden response has a 3xx status code
func (o *DeleteContactForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete contact forbidden response has a 4xx status code
func (o *DeleteContactForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete contact forbidden response has a 5xx status code
func (o *DeleteContactForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this delete contact forbidden response a status code equal to that given
func (o *DeleteContactForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the delete contact forbidden response
func (o *DeleteContactForbidden) Code() int {
	return 403
}

func (o *DeleteContactForbidden) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactForbidden  %+v", 403, o.Payload)
}

func (o *DeleteContactForbidden) String() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactForbidden  %+v", 403, o.Payload)
}

func (o *DeleteContactForbidden) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactNotFound creates a DeleteContactNotFound with default headers values
func NewDeleteContactNotFound() *DeleteContactNotFound {
	return &DeleteContactNotFound{}
}

/*
DeleteContactNotFound describes a response with status code 404, with default header values.

Resource was not found
*/
type DeleteContactNotFound struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this delete contact not found response has a 2xx status code
func (o *DeleteContactNotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete contact not found response has a 3xx status code
func (o *DeleteContactNotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete contact not found response has a 4xx status code
func (o *DeleteContactNotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete contact not found response has a 5xx status code
func (o *DeleteContactNotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this delete contact not found response a status code equal to that given
func (o *DeleteContactNotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the delete contact not found response
func (o *DeleteContactNotFound) Code() int {
	return 404
}

func (o *DeleteContactNotFound) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactNotFound  %+v", 404, o.Payload)
}

func (o *DeleteContactNotFound) String() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactNotFound  %+v", 404, o.Payload)
}

func (o *DeleteContactNotFound) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactUnprocessableEntity creates a DeleteContactUnprocessableEntity with default headers values
func NewDeleteContactUnprocessableEntity() *DeleteContactUnprocessableEntity {
	return &DeleteContactUnprocessableEntity{}
}

/*
DeleteContactUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type DeleteContactUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this delete contact unprocessable entity response has a 2xx status code
func (o *DeleteContactUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete contact unprocessable entity response has a 3xx status code
func (o *DeleteContactUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete contact unprocessable entity response has a 4xx status code
func (o *DeleteContactUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this delete contact unprocessable entity response has a 5xx status code
func (o *DeleteContactUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this delete contact unprocessable entity response a status code equal to that given
func (o *DeleteContactUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the delete contact unprocessable entity response
func (o *DeleteContactUnprocessableEntity) Code() int {
	return 422
}

func (o *DeleteContactUnprocessableEntity) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteContactUnprocessableEntity) String() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *DeleteContactUnprocessableEntity) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewDeleteContactInternalServerError creates a DeleteContactInternalServerError with default headers values
func NewDeleteContactInternalServerError() *DeleteContactInternalServerError {
	return &DeleteContactInternalServerError{}
}

/*
DeleteContactInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type DeleteContactInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *crm_models.Error
}

// IsSuccess returns true when this delete contact internal server error response has a 2xx status code
func (o *DeleteContactInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this delete contact internal server error response has a 3xx status code
func (o *DeleteContactInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this delete contact internal server error response has a 4xx status code
func (o *DeleteContactInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this delete contact internal server error response has a 5xx status code
func (o *DeleteContactInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this delete contact internal server error response a status code equal to that given
func (o *DeleteContactInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the delete contact internal server error response
func (o *DeleteContactInternalServerError) Code() int {
	return 500
}

func (o *DeleteContactInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteContactInternalServerError) String() string {
	return fmt.Sprintf("[DELETE /contacts][%d] deleteContactInternalServerError  %+v", 500, o.Payload)
}

func (o *DeleteContactInternalServerError) GetPayload() *crm_models.Error {
	return o.Payload
}

func (o *DeleteContactInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(crm_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
