// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/research/research_models"
)

// NewPostIndustriesParams creates a new PostIndustriesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostIndustriesParams() *PostIndustriesParams {
	return &PostIndustriesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostIndustriesParamsWithTimeout creates a new PostIndustriesParams object
// with the ability to set a timeout on a request.
func NewPostIndustriesParamsWithTimeout(timeout time.Duration) *PostIndustriesParams {
	return &PostIndustriesParams{
		timeout: timeout,
	}
}

// NewPostIndustriesParamsWithContext creates a new PostIndustriesParams object
// with the ability to set a context for a request.
func NewPostIndustriesParamsWithContext(ctx context.Context) *PostIndustriesParams {
	return &PostIndustriesParams{
		Context: ctx,
	}
}

// NewPostIndustriesParamsWithHTTPClient creates a new PostIndustriesParams object
// with the ability to set a custom HTTPClient for a request.
func NewPostIndustriesParamsWithHTTPClient(client *http.Client) *PostIndustriesParams {
	return &PostIndustriesParams{
		HTTPClient: client,
	}
}

/*
PostIndustriesParams contains all the parameters to send to the API endpoint

	for the post industries operation.

	Typically these are written to a http.Request.
*/
type PostIndustriesParams struct {

	/* IndustryRequest.

	   An array of new Industry records
	*/
	IndustryRequest *research_models.IndustryRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post industries params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostIndustriesParams) WithDefaults() *PostIndustriesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post industries params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostIndustriesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post industries params
func (o *PostIndustriesParams) WithTimeout(timeout time.Duration) *PostIndustriesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post industries params
func (o *PostIndustriesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post industries params
func (o *PostIndustriesParams) WithContext(ctx context.Context) *PostIndustriesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post industries params
func (o *PostIndustriesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post industries params
func (o *PostIndustriesParams) WithHTTPClient(client *http.Client) *PostIndustriesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post industries params
func (o *PostIndustriesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIndustryRequest adds the industryRequest to the post industries params
func (o *PostIndustriesParams) WithIndustryRequest(industryRequest *research_models.IndustryRequest) *PostIndustriesParams {
	o.SetIndustryRequest(industryRequest)
	return o
}

// SetIndustryRequest adds the industryRequest to the post industries params
func (o *PostIndustriesParams) SetIndustryRequest(industryRequest *research_models.IndustryRequest) {
	o.IndustryRequest = industryRequest
}

// WriteToRequest writes these params to a swagger request
func (o *PostIndustriesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.IndustryRequest != nil {
		if err := r.SetBodyParam(o.IndustryRequest); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
