// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package industry_companies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new industry companies API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for industry companies API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	DeleteIndustryCompany(params *DeleteIndustryCompanyParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteIndustryCompanyOK, error)

	GetIndustryCompanies(params *GetIndustryCompaniesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustryCompaniesOK, error)

	PostIndustryCompanies(params *PostIndustryCompaniesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustryCompaniesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
DeleteIndustryCompany deletes an industry company

Delete IndustryCompany record
*/
func (a *Client) DeleteIndustryCompany(params *DeleteIndustryCompanyParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*DeleteIndustryCompanyOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewDeleteIndustryCompanyParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "deleteIndustryCompany",
		Method:             "DELETE",
		PathPattern:        "/industrycompanies",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &DeleteIndustryCompanyReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*DeleteIndustryCompanyOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for deleteIndustryCompany: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
GetIndustryCompanies gets a list of industrycompanies

Return a list of all available IndustryCompanies
*/
func (a *Client) GetIndustryCompanies(params *GetIndustryCompaniesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*GetIndustryCompaniesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetIndustryCompaniesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "getIndustryCompanies",
		Method:             "GET",
		PathPattern:        "/industrycompanies",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &GetIndustryCompaniesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetIndustryCompaniesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for getIndustryCompanies: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

/*
PostIndustryCompanies adds a new industry company to salesforce devops net

IndustryCompany record to be added
*/
func (a *Client) PostIndustryCompanies(params *PostIndustryCompaniesParams, authInfo runtime.ClientAuthInfoWriter, opts ...ClientOption) (*PostIndustryCompaniesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostIndustryCompaniesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "postIndustryCompanies",
		Method:             "POST",
		PathPattern:        "/industrycompanies",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"http"},
		Params:             params,
		Reader:             &PostIndustryCompaniesReader{formats: a.formats},
		AuthInfo:           authInfo,
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostIndustryCompaniesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for postIndustryCompanies: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
