// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package observations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetObservationsParams creates a new GetObservationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetObservationsParams() *GetObservationsParams {
	return &GetObservationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetObservationsParamsWithTimeout creates a new GetObservationsParams object
// with the ability to set a timeout on a request.
func NewGetObservationsParamsWithTimeout(timeout time.Duration) *GetObservationsParams {
	return &GetObservationsParams{
		timeout: timeout,
	}
}

// NewGetObservationsParamsWithContext creates a new GetObservationsParams object
// with the ability to set a context for a request.
func NewGetObservationsParamsWithContext(ctx context.Context) *GetObservationsParams {
	return &GetObservationsParams{
		Context: ctx,
	}
}

// NewGetObservationsParamsWithHTTPClient creates a new GetObservationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetObservationsParamsWithHTTPClient(client *http.Client) *GetObservationsParams {
	return &GetObservationsParams{
		HTTPClient: client,
	}
}

/*
GetObservationsParams contains all the parameters to send to the API endpoint

	for the get observations operation.

	Typically these are written to a http.Request.
*/
type GetObservationsParams struct {

	/* Active.

	   Only retrieve active records?
	*/
	Active *bool

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* ObservationID.

	   Observation record ID
	*/
	ObservationID *string

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get observations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetObservationsParams) WithDefaults() *GetObservationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get observations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetObservationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get observations params
func (o *GetObservationsParams) WithTimeout(timeout time.Duration) *GetObservationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get observations params
func (o *GetObservationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get observations params
func (o *GetObservationsParams) WithContext(ctx context.Context) *GetObservationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get observations params
func (o *GetObservationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get observations params
func (o *GetObservationsParams) WithHTTPClient(client *http.Client) *GetObservationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get observations params
func (o *GetObservationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithActive adds the active to the get observations params
func (o *GetObservationsParams) WithActive(active *bool) *GetObservationsParams {
	o.SetActive(active)
	return o
}

// SetActive adds the active to the get observations params
func (o *GetObservationsParams) SetActive(active *bool) {
	o.Active = active
}

// WithLimit adds the limit to the get observations params
func (o *GetObservationsParams) WithLimit(limit *int64) *GetObservationsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get observations params
func (o *GetObservationsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithObservationID adds the observationID to the get observations params
func (o *GetObservationsParams) WithObservationID(observationID *string) *GetObservationsParams {
	o.SetObservationID(observationID)
	return o
}

// SetObservationID adds the observationId to the get observations params
func (o *GetObservationsParams) SetObservationID(observationID *string) {
	o.ObservationID = observationID
}

// WithOffset adds the offset to the get observations params
func (o *GetObservationsParams) WithOffset(offset *int64) *GetObservationsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get observations params
func (o *GetObservationsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WriteToRequest writes these params to a swagger request
func (o *GetObservationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Active != nil {

		// query param active
		var qrActive bool

		if o.Active != nil {
			qrActive = *o.Active
		}
		qActive := swag.FormatBool(qrActive)
		if qActive != "" {

			if err := r.SetQueryParam("active", qActive); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.ObservationID != nil {

		// query param observationId
		var qrObservationID string

		if o.ObservationID != nil {
			qrObservationID = *o.ObservationID
		}
		qObservationID := qrObservationID
		if qObservationID != "" {

			if err := r.SetQueryParam("observationId", qObservationID); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
