// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package topics

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetTopicsParams creates a new GetTopicsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetTopicsParams() *GetTopicsParams {
	return &GetTopicsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetTopicsParamsWithTimeout creates a new GetTopicsParams object
// with the ability to set a timeout on a request.
func NewGetTopicsParamsWithTimeout(timeout time.Duration) *GetTopicsParams {
	return &GetTopicsParams{
		timeout: timeout,
	}
}

// NewGetTopicsParamsWithContext creates a new GetTopicsParams object
// with the ability to set a context for a request.
func NewGetTopicsParamsWithContext(ctx context.Context) *GetTopicsParams {
	return &GetTopicsParams{
		Context: ctx,
	}
}

// NewGetTopicsParamsWithHTTPClient creates a new GetTopicsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetTopicsParamsWithHTTPClient(client *http.Client) *GetTopicsParams {
	return &GetTopicsParams{
		HTTPClient: client,
	}
}

/*
GetTopicsParams contains all the parameters to send to the API endpoint

	for the get topics operation.

	Typically these are written to a http.Request.
*/
type GetTopicsParams struct {

	/* Limit.

	   How many objects to return at one time

	   Format: int64
	*/
	Limit *int64

	/* Offset.

	   How many objects to skip?

	   Format: int64
	*/
	Offset *int64

	/* TopicID.

	   Topic record ID
	*/
	TopicID *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTopicsParams) WithDefaults() *GetTopicsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get topics params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetTopicsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get topics params
func (o *GetTopicsParams) WithTimeout(timeout time.Duration) *GetTopicsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get topics params
func (o *GetTopicsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get topics params
func (o *GetTopicsParams) WithContext(ctx context.Context) *GetTopicsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get topics params
func (o *GetTopicsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get topics params
func (o *GetTopicsParams) WithHTTPClient(client *http.Client) *GetTopicsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get topics params
func (o *GetTopicsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithLimit adds the limit to the get topics params
func (o *GetTopicsParams) WithLimit(limit *int64) *GetTopicsParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the get topics params
func (o *GetTopicsParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the get topics params
func (o *GetTopicsParams) WithOffset(offset *int64) *GetTopicsParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the get topics params
func (o *GetTopicsParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithTopicID adds the topicID to the get topics params
func (o *GetTopicsParams) WithTopicID(topicID *string) *GetTopicsParams {
	o.SetTopicID(topicID)
	return o
}

// SetTopicID adds the topicId to the get topics params
func (o *GetTopicsParams) SetTopicID(topicID *string) {
	o.TopicID = topicID
}

// WriteToRequest writes these params to a swagger request
func (o *GetTopicsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.TopicID != nil {

		// query param topicId
		var qrTopicID string

		if o.TopicID != nil {
			qrTopicID = *o.TopicID
		}
		qTopicID := qrTopicID
		if qTopicID != "" {

			if err := r.SetQueryParam("topicId", qTopicID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
